<?php
defined('BASEPATH') OR exit('No direct script access allowed');



class Master extends CI_Controller {

	function __construct() {
		parent::__construct();
		$this->load->library('encrypt');
		$this->load->library('form_validation');
		$this->load->model('MasterModel');
// 		date_default_timezone_set('Asia/Kolkata');

	}

// ********Courses Section***********

	function list_courses() {
		$data['title'] = "List Courses";
		$data['file_name'] = 'courses/index';
		$data['list_courses'] =$this->MasterModel->get_courses_without_dltflag();
		$this->load->view('admin_layout/master', $data);
	}

	function add_courses($course_id=false) {
		$data['title'] = "Add Courses";
		if(!empty($course_id))
		{
			$data['title'] = "Edit Courses";
			$data['course_id'] = $course_id;
			$filter_course['courses.course_id']=$course_id;
			$data['edit_data'] = $this->MasterModel->get_courses_without_dltflag($filter_course);
		}
		$data['file_name'] = 'courses/manage';
		$this->load->view('admin_layout/master', $data);
	}

	function save_courses($course_id=false) {

		$post_array = $this->input->post();

		$course_id = $this->input->post('course_id');
		$deleted_flag = $this->input->post('deleted_flag');
		/* Set validation rule for required field in the form */ 
		$this->form_validation->set_rules('course_name', 'Course Name', 'required'); 

		if ($this->form_validation->run() == FALSE) { 
			set_message(validation_errors());
			$this->session->set_flashdata('old_data',$this->input->post());
			redirect_back();
			return 0;
		} 
		else { 
			$course_data = array(
				'course_name' => $post_array['course_name'],
				'deleted_flag' => $post_array['deleted_flag'],

			);

			$this->db->trans_begin();

			if (!empty($course_id)) 
			{
				$update_id = $this->MasterModel->update_course($course_data, $course_id);
			}
			else
			{
				$insert_id=$this->MasterModel->add_course($course_data);
			}
		}

		/* Check transaction status */
		if($this->db->trans_status() === FALSE) {
			$this->db->trans_rollback();
			set_message("Something went wrong, Please try again");
			$this->session->set_flashdata('old_data',$post_array);
			redirect_back();
		}
		else {
			$this->db->trans_commit();


			$this->session->set_flashdata('success','Data Updated Successfully!!!');
			redirect('list_courses');

		}

	}

// ********Centre Section******************



	function list_centre() {
		$data['title'] = "List centre";
		$data['list_centres'] =$this->MasterModel->get_centre_withoutdlflg();
		$data['file_name'] = 'centre/index';
		$this->load->view('admin_layout/master', $data);
	}

	function add_centre($centre_id=false) {
		$data['title'] = "Add centre";
		if(!empty($centre_id))
		{
			$data['title'] = "Edit Centre";
			$data['centre_id'] = $centre_id;
			$filter_course['centre.centre_id']=$centre_id;
			$data['edit_data'] = $this->MasterModel->get_centres_edit($filter_course);
		}
		$data['file_name'] = 'centre/manage';
		$this->load->view('admin_layout/master', $data);
	}

	function save_centre($centre_id=false) {

		$post_array = $this->input->post();

		$centre_id = $this->input->post('centre_id');
		$this->form_validation->set_rules('centre_name', 'Centre Name', 'required'); 

		if ($this->form_validation->run() == FALSE) { 
			set_message(validation_errors());
			$this->session->set_flashdata('old_data',$this->input->post());
			redirect_back();
			return 0;
		} 
		else {

			$centre_data = array(
				'centre_name' => $post_array['centre_name'],
				'centre_email' => $post_array['centre_email'],
				'centre_address' => $post_array['centre_address'],
				'contact_person_name' => $post_array['contact_person_name'],
				'contact_person_mobile' => $post_array['contact_person_mobile'],
				'centre_direction' => $post_array['centre_direction'],
				'centre_status' => $post_array['centre_status'],
				'deleted_flag' => $post_array['deleted_flag'],

			);

			$this->db->trans_begin();

			if (!empty($centre_id)) 
			{
				$update_id = $this->MasterModel->update_centre($centre_data, $centre_id);
			}
			else
			{
				$insert_id=$this->MasterModel->add_centre($centre_data);
			}
		}

		/* Check transaction status */
		if($this->db->trans_status() === FALSE) {
			$this->db->trans_rollback();
			set_message("Something went wrong, Please try again");
			$this->session->set_flashdata('old_data',$post_array);
			redirect_back();
		}
		else {
			$this->db->trans_commit();


			$this->session->set_flashdata('success','Data Updated Successfully!!!');
			redirect('list_centre');

		}

	}
	
	public function changecentreStatus()
{
   $centre_id=$this->input->post('centre_id');
   $enable=$this->input->post('enable');
   if($enable==1)
   {
    $enable=0;
    
   }
   else 
   {
    $enable=1;
   }
   $data =array(
    "centre_status"=>$enable,
   );
  
   $userActivate=$this->MasterModel->update_centre($data,$centre_id);

   echo $userActivate;
}

// ********Leads Section******************

	function list_leads() {
		$data['title'] = "List leads";
		$get_array=$this->input->get();
		$search_filter_data=[];
		if(!empty($get_array['lead_createtime'])){
         $v2=explode('to',$get_array['lead_createtime']);
         $startdate=$v2[0];
         $enddate=$v2[1];
         
         $search_filter_data['WHERE']=('leads.created_at between "'.$startdate.'00:00:00" and "'.$enddate.' 23:59:59"');
         
      
      }
       $filter_leads=$search_filter_data;
		$data['list_leads'] =$this->MasterModel->get_leads($filter_leads);
		$data['file_name'] = 'leads/index';
		$this->load->view('admin_layout/master', $data);
	}

	function calculation()
	{	$data['title'] = "Calculate leads";

	$filter['SELECT'] ="count(leads.lead_id) as lead_cnt,centre_name,centre_id";
	$filter['ORDER_BY'] =array('centre.centre_name'=>'ASC');
	$filter['GROUP_BY'] ="centre.centre_id";
	$data['centre_wise_leads'] = $this->MasterModel->get_leads($filter);
// lq();
//       dsm($data['centre_wise_leads']);die;

	$data['file_name'] = 'leads/calculation';
	$this->load->view('admin_layout/master', $data);
}

function save_calculation()
{
	$this->db->trans_begin();

	$start_date = date('Y-m-d', strtotime($this->input->post('start_date'))); 
	$end_date = date('Y-m-d', strtotime($this->input->post('end_date'))); 
	$amount = $this->input->post('amount'); 


	$this->db->select('lead_id,created_at');
	$this->db->where('leads.created_at between "'.$start_date.' 00:00:00" and "'.$end_date.' 23:59:59"');
	$total_rs=$this->db->get('leads');
	//lq();die;

	$total_leads = $total_rs->num_rows();
    //dsm($total_leads);die;
	

	$this->db->select('count(leads.lead_id) as lead_cnt,leads.created_at as lead_date, centre.centre_id, centre.centre_name');
	$this->db->join('centre','centre.centre_id = leads.edu_centre_id','left');
	$this->db->where('leads.created_at between "'.$start_date.' 00:00:00" and "'.$end_date.' 23:59:59"');
	$this->db->order_by('centre.centre_name',"ASC");
    $this->db->group_by('centre.centre_id');
    $result=$this->db->get('leads');
    $rs = $result->result_array();

    $daily_amount = array(
		"start_date"=>$start_date,
		"end_date"=>$end_date,
		"amount"=>$amount,
		"total_leads"=>$total_leads,
		"created_at"=>date('Y-m-d H:i:s'),
		
	);

	$did_id =  $this->MasterModel->dataInsert('daily_amount', $daily_amount);
	$cost_per_lead = $amount / $total_leads; 
    //dsm($rs);die;
	foreach($rs AS $kC => $vC) 
	{
		
		$center_id = $vC['centre_id'];
		$lead_date = $vC['lead_date'];
		$number_of_leads = $vC['lead_cnt'];
		$centre_total_lead_cost = $number_of_leads * $cost_per_lead;

		$center_leads_daily = array(
		"did_id"=>$did_id,
		"centre_id"=>$center_id,
		"cost_per_lead"=>$cost_per_lead,
		"number_of_leads"=>$number_of_leads,
		"total_lead_cost"=>$centre_total_lead_cost,
		"lead_date"=>$lead_date,
		);

		$insert_each_row =  $this->MasterModel->dataInsert('cost_per_lead', $center_leads_daily);

	} 
	if($this->db->trans_status() === FALSE) {
		$this->db->trans_rollback();
		set_message("Something went wrong, Please try again");

		redirect_back();
	}
	else {

		$this->db->trans_commit();
		$this->session->set_flashdata('success','Data Updated Successfully!!!');
		redirect(base_url()."show_calc/".$did_id);
	}

}

function calculation_result()
{
	$data['title'] = "Lead Calculation Result";
	$did_id=$this->uri->segment(2);
    $currentdate = date('d-m-Y H:i:s');
	$result = $this->MasterModel->get_calculated_result($did_id);
	$list_centre =  $this->MasterModel->get_centre_dlflg();
	//dsm($result);die;
	
	$start_date = date('d-m-Y', strtotime($result[0]['start_date']));
    $end_date = date('d-m-Y', strtotime($result[0]['end_date']));
    $total_leads = $result[0]['total_leads'];
    $amount = $result[0]['amount'];
    $btn = "";
    $btn.="<div style='text-align:centre'>";
    $btn.="<a href='https://arenaanimationmumbai.com/calc' style='padding:15px 15px;background:#4d90fe;color:#fff; text-decoration:none'>Go back</a>";
    $btn.="</div>";
    echo $btn;
    
    $html ="";
    $html .= "<h3>Centre Wise Lead Calculation</h3>";
    $html .= "<table cellpadding='4' cellspacing='0'>";

    $html .= "<tr>";
    $html .= "<td style='color:#083d77;font-weight: 600;'>Amount Spend</td>";
    $html .= "<td><span style='color:#083d77;font-weight: 600;'>:</span>  $amount</td>";
    $html .= "</tr>";

    $html .= "<tr>";
    $html .= "<td style='color:#083d77;font-weight: 600;'>Start Date</td>";
    $html .= "<td><span style='color:#083d77;font-weight: 600;'>:</span>  $start_date</td>";
    $html .= "</tr>";

    $html .= "<tr>";
    $html .= "<td style='color:#083d77;font-weight: 600;'>End Date</td>";
    $html .= "<td><span style='color:#083d77;font-weight: 600;'>:</span> $end_date</td>";
    $html .= "</tr>";

    $html .= "<tr>";
    $html .= "<td style='color:#083d77;font-weight: 600;'>Total Leads</td>";
    $html .= "<td><span style='color:#083d77;font-weight: 600;'>:</span> $total_leads</td>";
    $html .= "</tr>";
    $html .= "</table>";
    $html .= "<br>";
    $html .= "<table border='1' cellpadding='10' cellspacing='0'>";
    $html .= "<thead style='background: #E5E4E2;'>";
    $html .= "<tr>";
    $html .= "<th>Sr.No.</th>
              <th>Centre Name</th>
              <th>No. Of Leads</th>
              <th>Cost Per Lead (&#8377;)</th>
              <th>Total Lead Cost (&#8377;)</th>";
             
    $html .= "</tr>";
    $html .= "</thead>";
    $html .= "<tbody>";
    $srno=1;
   
    $grand_total_lead_cost=0;
    foreach ($result as $key => $value) 
    {
        $centre_name = $value['centre_name'];
        $cost_per_lead = number_format((float)$value['cost_per_lead'], 2, '.', ''); 
        $number_of_leads = $value['number_of_leads'];
        $total_lead_cost = number_format((float)$value['total_lead_cost'], 2, '.', ''); 
        $lead_date = date('d-m-Y H:i:s', strtotime($value['lead_date'])); 
        
        
    $grand_total_lead_cost+=$total_lead_cost;
    $html .= "<tr>";
    $html .= "<td align='center'>$srno</td>";
    $html .= "<td>$centre_name</td>";
    $html .= "<td align='center'>$number_of_leads</td>";
    $html .= "<td align='center'>$cost_per_lead</td>";
    $html .= "<td align='center'> $total_lead_cost</td>";
   
   
    $html .= "</tr>";
    $srno++;
    }
    
    $html .= "</tbody>";
    $html .= "<tfoot >";
    $html .= "<tr style='background: #E5E4E2;'>";
    $html .= "<th colspan=2>Total</th>";
    
    $html .= "<th>$total_leads</th>";
    $html .= "<th></th>";
    $html .= "<th>&#8377; $grand_total_lead_cost</th>";
    
   
    $html .= "</tr>";
    $html .= "</tfoot>";
    $html .= "</table>";
    
  echo $html;
   
    $emailArray = [];
    // centre list to get all centre email to send report to all emails  
   foreach ($list_centre as $kR => $vR) 
    {
        $emailArray[$kR] = $vR['centre_email'];
       
        
    }
    $data['centre_email'] = $emailArray;
    $centre_email = implode(", ", $data['centre_email']);
  
    //dsm($centre_email);die;
   //$centre_email ="trupti@emaginationz.net,info@emaginationz.net";

    $config = array(
                'protocol'  => 'smtp',
                'smtp_host' => '216.48.177.180',
                'smtp_port' => 25,
                'smtp_user' => 'info@arenaanimationmumbai.com',
                'smtp_pass' => '#arenaanimation!@2023',
                'mailtype'  => 'html',
                'charset'   => 'utf-8',
                'wordwrap'=> TRUE,
                'mailtype' => 'html',
                'bcc_batch_mode' => TRUE,
                );
                $this->email->initialize($config);
                $this->email->set_mailtype("html");
                $this->email->set_newline("\r\n");
                $fromemail="info@arenaanimationmumbai.com";
                $toemail = $centre_email;
                
                $subject = "Centre Wise Leads for $start_date to $end_date for amount $amount";
                
                $this->email->initialize($config);

                $this->email->to($toemail);
                $this->email->bcc('info@emaginationz.net,trupti@emaginationz.net,aishwary.tiwari@aptech.ac.in');
                $this->email->from($fromemail, 'Arena Animation');
                $this->email->subject($subject);
                $this->email->message($html);
                $mail = $this->email->send();
                if($mail)
                {
                    echo "Mailed Successfully";
                }

}


}