<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class MasterModel extends CI_Model {

    public function __construct() {
        parent::__construct();
        // date_default_timezone_set('Asia/Kolkata');

    }
// ********Courses Section***********

    public function add_course($data) {


        $data['created_at']=date('Y-m-d H:i:s');

        $this->db->insert('courses',$data); 
        return $this->db->insert_id();
    }

    public function update_course($data, $edit_id) {
        $this->db->where('course_id',$edit_id);
        return $this->db->update('courses',$data);
    } 

    public function get_courses($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->where('courses.deleted_flag',false);
        $this->db->order_by('course_name',"ASC");
        $rs=$this->db->get('courses');
//lq();exit;
        return $rs->result_array();
    }
    public function get_courses_without_dltflag($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->order_by('course_name',"ASC");
        $rs=$this->db->get('courses');
//lq();exit;
        return $rs->result_array();
    }

// ********Centre Section***********

    public function add_centre($data) {


        $data['created_at']=date('Y-m-d H:i:s');

        $this->db->insert('centre',$data); 
        return $this->db->insert_id();
    }

    public function update_centre($data, $edit_id) {
        $this->db->where('centre_id',$edit_id);
        return $this->db->update('centre',$data);
    } 

    public function get_centres($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->where('centre.centre_status',1);
        $this->db->order_by('centre.centre_name',"ASC");
        $rs=$this->db->get('centre');
//lq();exit;
        return $rs->result_array();
    }
    public function get_centres_edit($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        //$this->db->where('centre.centre_status',1);
        $this->db->order_by('centre.centre_name',"ASC");
        $rs=$this->db->get('centre');
//lq();exit;
        return $rs->result_array();
    }
    
    public function get_centre_dlflg($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        $this->db->where('centre.deleted_flag',false);
        $this->db->order_by('centre.centre_name',"ASC");
        $rs=$this->db->get('centre');
//lq();exit;
        return $rs->result_array();
    }
    
    public function get_centre_withoutdlflg($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }

        
        $this->db->order_by('centre.centre_name',"ASC");
        $rs=$this->db->get('centre');
//lq();exit;
        return $rs->result_array();
    }

    


// ********Leads Section***********

    public function get_leads($filter=false) {    
        if($filter) {
            apply_filter($filter);
        }
        $this->db->select('leads.*,courses.*,leads.created_at as leads_date');
        $this->db->from('leads');
        // $this->db->join('centre','centre.centre_id = leads.edu_centre_id','left');
        $this->db->join('courses','courses.course_id = leads.edu_course_id','left');
        $this->db->order_by('leads.created_at',"DESC");
        $rs=$this->db->get();
 //lq();exit;
        return $rs->result_array();
    }

    public function add_leads($data) {


        $data['created_at']=date('Y-m-d H:i:s');

        $q = $this->db->insert('leads',$data); 
        return $q;
    }

    public function dataInsert($tableName, $insertData = []) {
        $this->db->insert($tableName, $insertData);
        return $this->db->insert_id();

    }
    public function cost_per_lead_Insert($data) {
        $rstpArray = [];
        foreach ($data AS $rstpK => $rstpV) {

            $rstpArray[$rstpK]['did_id'] =$rstpV['did_id'];
            $rstpArray[$rstpK]['centre_id'] =$rstpV['centre_id'];
            $rstpArray[$rstpK]['cost_per_lead'] =$rstpV['cost_per_lead'];
            $rstpArray[$rstpK]['number_of_leads'] =$rstpV['number_of_leads'];
            $rstpArray[$rstpK]['total_lead_cost'] =$rstpV['total_lead_cost'];

        }
        $rs =  $this->db->insert_batch('cost_per_lead', $rstpArray);
        return $rs;
    }

    public function get_calculated_result($did_id)
    {
        // $this->db->join('centre','centre.centre_id = cost_per_lead.centre_id','left');
        $this->db->join('daily_amount','daily_amount.did = cost_per_lead.did_id','left');
        $this->db->where('cost_per_lead.did_id',$did_id);
        // $this->db->where('centre.deleted_flag',0);
        $rs=$this->db->get('cost_per_lead');
        return $rs->result_array();
    }
    
    

}


